----------------------------------------------------------------------------------------
PRINT 'Towa e primeren block. Nedej da redaktirash!!! Copiraj '
GO
----------------------------------------------------------------------------------------

BEGIN TRAN
DECLARE		@ERR INT
SET			@ERR = 0

SET 		NOCOUNT ON

--- your sql code here
SET @ERR = @ERR+@@ERROR

IF @ERR = 0 BEGIN
	PRINT 'Ok: ' + CONVERT(VARCHAR,@@TRANCOUNT)
	COMMIT
END ELSE BEGIN
	PRINT '!!!!!!!!!!!!! Ooooooooooops: ' + CONVERT(VARCHAR,@ERR) + ' !!!!!!!!!!!!!!!!!!!'
	ROLLBACK
END
GO


----------------------------------------------------------------------------------------
PRINT 'Dobawqme kolona Sales_ID w Cash i wdigame relatsiq sys sales_Main'
GO
----------------------------------------------------------------------------------------

BEGIN TRAN
DECLARE		@ERR INT
SET			@ERR = 0

SET 		NOCOUNT ON

IF NOT EXISTS (
			SELECT		* 
			FROM		information_schema.columns
			WHERE		TABLE_NAME = 'Cash' 
						AND COLUMN_NAME = 'Sales_ID')
BEGIN
			ALTER TABLE Cash ADD
				Sales_ID UNIQUEIDENTIFIER NULL
END
SET	@ERR = @ERR+@@ERROR

IF NOT EXISTS (
			select *
			from information_schema.referential_constraints
			where CONSTRAINT_NAME='FK_Cash_sales_Main')
BEGIN
			ALTER TABLE Cash ADD CONSTRAINT FK_Cash_sales_Main
				FOREIGN KEY (Sales_ID) REFERENCES sales_Main (ID)
END
SET @ERR = @ERR+@@ERROR

IF @ERR = 0 BEGIN
	PRINT 'Ok: ' + CONVERT(VARCHAR,@@TRANCOUNT)
	COMMIT
END ELSE BEGIN
	PRINT '!!!!!!!!!!!!! Ooooooooooops: ' + CONVERT(VARCHAR,@ERR) + ' !!!!!!!!!!!!!!!!!!!'
	ROLLBACK
END
GO

----------------------------------------------------------------------------------------
PRINT 'Dobawqme kolona DTInvoice, DTCreditNote, DTPKO w MPSetup i wdigame relatsiite'
GO
----------------------------------------------------------------------------------------

BEGIN TRAN
DECLARE		@ERR INT
SET			@ERR = 0

SET 		NOCOUNT ON

IF NOT EXISTS (
			SELECT		* 
			FROM		information_schema.columns
			WHERE		TABLE_NAME = 'MPSetup' 
						AND COLUMN_NAME = 'DTInvoice')
BEGIN
			ALTER TABLE MPSETUP ADD
				DTInvoice UNIQUEIDENTIFIER NULL
END
SET	@ERR = @ERR+@@ERROR

IF NOT EXISTS (
			SELECT		* 
			FROM		information_schema.columns
			WHERE		TABLE_NAME = 'MPSetup' 
						AND COLUMN_NAME = 'DTCreditNote')
BEGIN
			ALTER TABLE MPSETUP ADD
				DTCreditNote UNIQUEIDENTIFIER NULL
END
SET	@ERR = @ERR+@@ERROR

IF NOT EXISTS (
			SELECT		* 
			FROM		information_schema.columns
			WHERE		TABLE_NAME = 'MPSetup' 
						AND COLUMN_NAME = 'DTPKO')
BEGIN
			ALTER TABLE MPSETUP ADD
				DTPKO UNIQUEIDENTIFIER NULL
END
SET	@ERR = @ERR+@@ERROR


IF NOT EXISTS (
			select *
			from information_schema.referential_constraints
			where CONSTRAINT_NAME='FK_MPSetup_m_DocTypes3')
BEGIN
			ALTER TABLE MPSETUP ADD CONSTRAINT FK_MPSetup_m_DocTypes3
				FOREIGN KEY (DTCreditNote) REFERENCES m_DocTypes (ID)
END
SET @ERR = @ERR+@@ERROR

IF NOT EXISTS (
			select *
			from information_schema.referential_constraints
			where CONSTRAINT_NAME='FK_MPSetup_m_DocTypes2')
BEGIN
			ALTER TABLE MPSETUP ADD CONSTRAINT FK_MPSetup_m_DocTypes2
				FOREIGN KEY (DTInvoice) REFERENCES m_DocTypes (ID)
END
SET @ERR = @ERR+@@ERROR

IF NOT EXISTS (
			select *
			from information_schema.referential_constraints
			where CONSTRAINT_NAME='FK_MPSetup_m_DocTypes4')
BEGIN
			ALTER TABLE MPSETUP ADD CONSTRAINT FK_MPSetup_m_DocTypes4
				FOREIGN KEY (DTPKO) REFERENCES m_DocTypes (ID)
END
SET @ERR = @ERR+@@ERROR


IF @ERR = 0 BEGIN
	PRINT 'Ok: ' + CONVERT(VARCHAR,@@TRANCOUNT)
	COMMIT
END ELSE BEGIN
	PRINT '!!!!!!!!!!!!! Ooooooooooops: ' + CONVERT(VARCHAR,@ERR) + ' !!!!!!!!!!!!!!!!!!!'
	ROLLBACK
END
GO

----------------------------------------------------------------------------------------
PRINT 'Dobawqme kolona DefPKOPurpose_ID w MPSetup i wdigame relaciata'
GO
----------------------------------------------------------------------------------------

BEGIN TRAN
DECLARE		@ERR INT
SET			@ERR = 0

SET 		NOCOUNT ON

IF NOT EXISTS (
			SELECT		* 
			FROM		information_schema.columns
			WHERE		TABLE_NAME = 'MPSETUP' 
						AND COLUMN_NAME = 'DefPKOPurpose_ID')
BEGIN
			ALTER TABLE MPSETUP ADD
				DefPKOPurpose_ID INT NULL
END
SET	@ERR = @ERR+@@ERROR

IF NOT EXISTS (
			select *
			from information_schema.referential_constraints
			where CONSTRAINT_NAME='FK_MPSetup_Purpose')
BEGIN
			ALTER TABLE MPSetup ADD CONSTRAINT FK_MPSetup_Purpose
				FOREIGN KEY (DefPKOPurpose_ID) REFERENCES Purpose (ID)
END
SET @ERR = @ERR+@@ERROR

IF @ERR = 0 BEGIN
	PRINT 'Ok: ' + CONVERT(VARCHAR,@@TRANCOUNT)
	COMMIT
END ELSE BEGIN
	PRINT '!!!!!!!!!!!!! Ooooooooooops: ' + CONVERT(VARCHAR,@ERR) + ' !!!!!!!!!!!!!!!!!!!'
	ROLLBACK
END
GO

----------------------------------------------------------------------------------------
PRINT 'Dobawqme relacia m/u fakturi i tipowe dokuemnti'
GO
----------------------------------------------------------------------------------------

BEGIN TRAN
DECLARE		@ERR INT
SET			@ERR = 0

SET 		NOCOUNT ON

IF NOT EXISTS (
			select *
			from information_schema.referential_constraints
			where CONSTRAINT_NAME='FK_inv_Main_m_DocTypes')
BEGIN
			ALTER TABLE inv_Main ADD CONSTRAINT FK_inv_Main_m_DocTypes
				FOREIGN KEY (DocType_ID) REFERENCES m_DocTypes (ID)
END
SET @ERR = @ERR+@@ERROR

IF @ERR = 0 BEGIN
	PRINT 'Ok: ' + CONVERT(VARCHAR,@@TRANCOUNT)
	COMMIT
END ELSE BEGIN
	PRINT '!!!!!!!!!!!!! Ooooooooooops: ' + CONVERT(VARCHAR,@ERR) + ' !!!!!!!!!!!!!!!!!!!'
	ROLLBACK
END
GO

----------------------------------------------------------------------------------------
PRINT 'Contragent.InvPercent = 0% wmesto 100% sled pyrwonachalno preliwane'
GO
----------------------------------------------------------------------------------------

BEGIN TRAN
DECLARE		@ERR INT
SET			@ERR = 0

SET 		NOCOUNT ON

UPDATE		Contragents
SET			InvPercent = 0
WHERE		InvPercent = 100
SET @ERR = @ERR+@@ERROR

IF @ERR = 0 BEGIN
	PRINT 'Ok: ' + CONVERT(VARCHAR,@@TRANCOUNT)
	COMMIT
END ELSE BEGIN
	PRINT '!!!!!!!!!!!!! Ooooooooooops: ' + CONVERT(VARCHAR,@ERR) + ' !!!!!!!!!!!!!!!!!!!'
	ROLLBACK
END
GO

----------------------------------------------------------------------------------------
PRINT 'Preliwame personi ot Contragents wyw cg_Persons i pochistwane na Contragenti'
GO
----------------------------------------------------------------------------------------

BEGIN TRAN
DECLARE		@ERR INT
SET			@ERR = 0

SET 		NOCOUNT ON

IF EXISTS (
			select *
			from information_schema.columns
			where column_name = 'Prs_CODE' and table_name = 'Contragents'
			)
BEGIN
EXEC('
			--- internal persons
			INSERT		cg_Persons(ID
						, Cg_CODE
						, Code
						, Name
						, EGN
						, Address
						, EMail
						, Phone_sl
						, Position_ID
						, InActive)
			SELECT		NEWID()
						, s.Cg_Potrebitel AS Cg_CODE
						, Code
						, Name
						, EGN
						, Address
						, EMail
						, Phone
						, Prs_POST AS Position_ID
						, 1-Active AS InActive
			FROM		Contragents c, MPSetup s
			WHERE		c.Type = 3
						AND isintprs = 1
						AND c.Name NOT IN (SELECT Name FROM cg_Persons)
--			SET @ERR = @ERR+@@ERROR
			
			--- MOL-owe
			INSERT		cg_Persons(ID
						, Cg_CODE
						, Code
						, Name
						, EGN
						, Address
						, EMail
						, Phone_sl
						, Position_ID
						, InActive)
			SELECT		NEWID()
						, p.Code AS Cg_CODE
						, c.Code
						, c.Name
						, c.EGN
						, c.Address
						, c.EMail
						, c.Phone
						, c.Prs_POST AS Position_ID
						, 1-c.Active AS InActive
			FROM		Contragents c
			JOIN		Contragents p
			ON			c.Code = p.Prs_CODE
			WHERE		c.Type = 3
						AND c.isintprs = 0
						AND c.Name NOT IN (SELECT Name FROM cg_Persons WHERE Cg_CODE = p.Code)
--			SET @ERR = @ERR+@@ERROR
			
			--- mahame self-joina
			UPDATE		Contragents
			SET			Prs_CODE = NULL
--			SET @ERR = @ERR+@@ERROR
			
			DECLARE		@Affected INT
			
			IF			OBJECT_ID(''tempdb..#TmpCg'') IS NOT NULL
						DROP TABLE #TmpCg
			
			SELECT		Code
			INTO		#TmpCg
			FROM		Contragents
			LEFT JOIN	Cash
			ON			Contragents.Code = Cash.Cg_CODE
			WHERE		Type=3
						AND Cash.ID IS NULL
--			SET @ERR = @ERR+@@ERROR
			
			SET			@Affected = 0
			
			WHILE		EXISTS (SELECT * FROM #TmpCg)
			BEGIN
						DECLARE		@Cg_CODE VARCHAR(16)
			
						SELECT		TOP 1 @Cg_CODE = Code 
						FROM		#TmpCg
			
						DELETE		#TmpCg
						WHERE		Code = @Cg_CODE
			
						DELETE		m_Pr
						FROM		Contragents
						WHERE		m_Pr.ID = Contragents.ID
									AND Contragents.Code = @Cg_CODE
			
						IF			@@ERROR = 0
						BEGIN
									DELETE		Contragents
									WHERE		Code = @Cg_CODE
						
									IF			@@ERROR = 0
												SET @Affected = @Affected+1
						END
			END
			
			DROP TABLE	#TmpCg
			
			SELECT		CONVERT(VARCHAR,@Affected) + '' record(s) affected''
')
SET @ERR = @ERR+@@ERROR
END

IF @ERR = 0 BEGIN
	PRINT 'Ok: ' + CONVERT(VARCHAR,@@TRANCOUNT)
	COMMIT
END ELSE BEGIN
	PRINT '!!!!!!!!!!!!! Ooooooooooops: ' + CONVERT(VARCHAR,@ERR) + ' !!!!!!!!!!!!!!!!!!!'
	ROLLBACK
END
GO

----------------------------------------------------------------------------------------
PRINT 'Dobawqme Prs_ID wyw Track i preliwame Cg_CODE wyw Prs_ID'
GO
----------------------------------------------------------------------------------------

BEGIN TRAN
DECLARE		@ERR INT
SET			@ERR = 0

SET 		NOCOUNT ON


IF NOT EXISTS (
			select *
			from information_schema.columns
			where column_name = 'Prs_ID' and table_name = 'Track'
			)
BEGIN

			ALTER TABLE Track ADD Prs_ID UNIQUEIDENTIFIER NULL
			SET @ERR = @ERR+@@ERROR
			
			ALTER TABLE Track ADD CONSTRAINT FK_Track_Persons 
					FOREIGN KEY (Prs_ID) REFERENCES cg_Persons (ID)
			SET @ERR = @ERR+@@ERROR
		
			EXEC ( 'UPDATE		Track
					SET			Prs_ID = p.ID
					FROM		Track t
					JOIN		Contragents c
					ON			t.Cg_CODE = c.Code
					JOIN		cg_Persons p
					ON			c.Name = p.Name')
			SET @ERR = @ERR+@@ERROR

			ALTER TABLE Track DROP CONSTRAINT FK_Track_Contragents
			SET @ERR = @ERR+@@ERROR

			ALTER TABLE Track DROP COLUMN Cg_CODE
			SET @ERR = @ERR+@@ERROR
END

IF @ERR = 0 BEGIN
	PRINT 'Ok: ' + CONVERT(VARCHAR,@@TRANCOUNT)
	COMMIT
END ELSE BEGIN
	PRINT '!!!!!!!!!!!!! Ooooooooooops: ' + CONVERT(VARCHAR,@ERR) + ' !!!!!!!!!!!!!!!!!!!'
	ROLLBACK
END
GO

----------------------------------------------------------------------------------------
PRINT 'Dobawqme Prs_ID wyw TrackCash i preliwame Cg_CODE wyw Prs_ID'
GO
----------------------------------------------------------------------------------------

BEGIN TRAN
DECLARE		@ERR INT
SET			@ERR = 0

SET 		NOCOUNT ON

IF NOT EXISTS (
			select *
			from information_schema.columns
			where column_name = 'Prs_ID' and table_name = 'TrackCash'
			)
BEGIN
			ALTER TABLE TrackCash ADD Prs_ID UNIQUEIDENTIFIER NULL
			SET @ERR = @ERR+@@ERROR
			
			ALTER TABLE TrackCash ADD CONSTRAINT FK_TrackCash_Persons 
					FOREIGN KEY (Prs_ID) REFERENCES cg_Persons (ID)
			SET @ERR = @ERR+@@ERROR
		
			EXEC ( 'UPDATE		TrackCash
					SET			Prs_ID = p.ID
					FROM		TrackCash t
					JOIN		Contragents c
					ON			t.Cg_CODE = c.Code
					JOIN		cg_Persons p
					ON			c.Name = p.Name')
			SET @ERR = @ERR+@@ERROR

			ALTER TABLE TrackCash DROP CONSTRAINT FK_TrackCash_Contragents
			SET @ERR = @ERR+@@ERROR

			DROP INDEX TrackCash.IX_TrackCash_1
			SET @ERR = @ERR+@@ERROR

			ALTER TABLE TrackCash DROP COLUMN Cg_CODE
			SET @ERR = @ERR+@@ERROR
END

IF @ERR = 0 BEGIN
	PRINT 'Ok: ' + CONVERT(VARCHAR,@@TRANCOUNT)
	COMMIT
END ELSE BEGIN
	PRINT '!!!!!!!!!!!!! Ooooooooooops: ' + CONVERT(VARCHAR,@ERR) + ' !!!!!!!!!!!!!!!!!!!'
	ROLLBACK
END
GO

----------------------------------------------------------------------------------------
PRINT 'Dobawqme Prs_ID wyw TrackFuel i preliwame Cg_CODE wyw Prs_ID'
GO
----------------------------------------------------------------------------------------

BEGIN TRAN
DECLARE		@ERR INT
SET			@ERR = 0

SET 		NOCOUNT ON

IF NOT EXISTS (
			select *
			from information_schema.columns
			where column_name = 'Prs_ID' and table_name = 'TrackFuel'
			)
BEGIN
			ALTER TABLE TrackFuel ADD Prs_ID UNIQUEIDENTIFIER NULL
			SET @ERR = @ERR+@@ERROR
			
			ALTER TABLE TrackFuel ADD CONSTRAINT FK_TrackFuel_Persons 
					FOREIGN KEY (Prs_ID) REFERENCES cg_Persons (ID)
			SET @ERR = @ERR+@@ERROR
		
			EXEC ( 'UPDATE		TrackFuel
					SET			Prs_ID = p.ID
					FROM		TrackFuel t
					JOIN		Contragents c
					ON			t.Cg_CODE = c.Code
					JOIN		cg_Persons p
					ON			c.Name = p.Name')
			SET @ERR = @ERR+@@ERROR

			ALTER TABLE TrackFuel DROP CONSTRAINT FK_TrackFuel_Contragents
			SET @ERR = @ERR+@@ERROR

			DROP INDEX TrackFuel.IX_TrackFuel_1
			SET @ERR = @ERR+@@ERROR

			ALTER TABLE TrackFuel DROP COLUMN Cg_CODE
			SET @ERR = @ERR+@@ERROR
END

IF @ERR = 0 BEGIN
	PRINT 'Ok: ' + CONVERT(VARCHAR,@@TRANCOUNT)
	COMMIT
END ELSE BEGIN
	PRINT '!!!!!!!!!!!!! Ooooooooooops: ' + CONVERT(VARCHAR,@ERR) + ' !!!!!!!!!!!!!!!!!!!'
	ROLLBACK
END
GO

----------------------------------------------------------------------------------------
PRINT 'Pochistwame contragenti i personi. Prawim cg_Persons.Code UNIQUE. Setwame default person'
GO
----------------------------------------------------------------------------------------

BEGIN TRAN
DECLARE		@ERR INT
SET			@ERR = 0

SET 		NOCOUNT ON

IF NOT EXISTS (
			select *
			from information_schema.table_constraints
			where TABLE_NAME = 'cg_Persons' AND CONSTRAINT_NAME='IX_Code')
BEGIN

			--- pochistwame contragenti wyw m_Pr
			DELETE		m_Pr
			FROM		m_Pr p
			LEFT JOIN	Contragents c
			ON			p.ID = c.ID
			WHERE		p.PrCategory_ID = 1
						AND c.ID IS NULL
			SET @ERR = @ERR+@@ERROR
			
			UPDATE		m_Pr
			SET			PrCategory_ID=1
			FROM		m_Pr p
			JOIN		Contragents c
			ON			p.ID = c.ID
			WHERE		p.PrCategory_ID <> 1 
			SET @ERR = @ERR+@@ERROR
			
			-- pochistwame priznatsi
			DELETE		m_Pr
			WHERE		PrCategory_ID=2
						AND ID NOT IN (SELECT ID FROM cg_Persons)
			SET @ERR = @ERR+@@ERROR
			
			--- pochistwame dublikati wyw cg_Persons
			UPDATE 		cg_Persons
			SET			Code = '!' + LEFT(CONVERT(VARCHAR(50), NEWID()), 6)
			WHERE		(CODE IN (
								SELECT		code
								FROM		cg_Persons
								GROUP BY	code
								HAVING		count(*) > 1
								) 
						OR Code IS NULL)
						AND ID NOT IN (
								SELECT		MIN(CONVERT(VARCHAR(50), ID)) AS ID
								FROM		cg_Persons
								WHERE		Code IN (
											SELECT		code
											FROM		cg_Persons
											GROUP BY	code
											HAVING		count(*) > 1)
								GROUP by 	code 
			)
			SET @ERR = @ERR+@@ERROR
			
		
			--- prawim Code na personi unikalen
			ALTER TABLE cg_Persons ALTER COLUMN Code VARCHAR(16) NOT NULL
			SET @ERR = @ERR+@@ERROR
		
			ALTER TABLE cg_Persons ADD CONSTRAINT IX_Code UNIQUE(Code)
			SET @ERR = @ERR+@@ERROR
		
			--- default persona
			UPDATE		cg_Persons
			SET			IsMol = (CASE WHEN p.Code = s.Code THEN 1 ELSE 0 END)
						, IsResp = (CASE WHEN p.Code = s.Code THEN 1 ELSE 0 END)
						, IsDefault = (CASE WHEN p.Code = s.Code THEN 1 ELSE 0 END)
			FROM		cg_Persons p
			JOIN		(
						SELECT		Cg_Code, MAX(Code) AS Code
						FROM		cg_Persons
						GROUP BY	cg_Code
						HAVING		MAX(CONVERT(INT, IsDefault)) = 0
						) s
			ON			p.Cg_Code = s.Cg_Code
			SET @ERR = @ERR+@@ERROR

END

IF @ERR = 0 BEGIN
	PRINT 'Ok: ' + CONVERT(VARCHAR,@@TRANCOUNT)
	COMMIT
END ELSE BEGIN
	PRINT '!!!!!!!!!!!!! Ooooooooooops: ' + CONVERT(VARCHAR,@ERR) + ' !!!!!!!!!!!!!!!!!!!'
	ROLLBACK
END
GO

----------------------------------------------------------------------------------------
PRINT 'Dobawqme kolona PKOGType w MPSetup '
GO
----------------------------------------------------------------------------------------

BEGIN TRAN
DECLARE		@ERR INT
SET			@ERR = 0

SET 		NOCOUNT ON

IF NOT EXISTS (
			SELECT		* 
			FROM		information_schema.columns
			WHERE		TABLE_NAME = 'MPSETUP' 
						AND COLUMN_NAME = 'PKOGType')
BEGIN
			ALTER TABLE MPSETUP ADD
				PKOGType INT NULL
END
SET	@ERR = @ERR+@@ERROR

IF @ERR = 0 BEGIN
	PRINT 'Ok: ' + CONVERT(VARCHAR,@@TRANCOUNT)
	COMMIT
END ELSE BEGIN
	PRINT '!!!!!!!!!!!!! Ooooooooooops: ' + CONVERT(VARCHAR,@ERR) + ' !!!!!!!!!!!!!!!!!!!'
	ROLLBACK
END
GO

----------------------------------------------------------------------------------------
PRINT 'Dobawqme kolona PKOFromSaleGener w MPSetup '
GO
----------------------------------------------------------------------------------------

BEGIN TRAN
DECLARE		@ERR INT
SET			@ERR = 0

SET 		NOCOUNT ON

IF NOT EXISTS (
			SELECT		* 
			FROM		information_schema.columns
			WHERE		TABLE_NAME = 'MPSETUP' 
						AND COLUMN_NAME = 'PKOFromSaleGener')
BEGIN
			ALTER TABLE MPSETUP ADD
				PKOFromSaleGener BIT NULL
END
SET	@ERR = @ERR+@@ERROR

IF @ERR = 0 BEGIN
	PRINT 'Ok: ' + CONVERT(VARCHAR,@@TRANCOUNT)
	COMMIT
END ELSE BEGIN
	PRINT '!!!!!!!!!!!!! Ooooooooooops: ' + CONVERT(VARCHAR,@ERR) + ' !!!!!!!!!!!!!!!!!!!'
	ROLLBACK
END
GO


----------------------------------------------------------------------------------------
PRINT 'Mahame kolona Purp_ID ot TrackCash'
GO
----------------------------------------------------------------------------------------

BEGIN TRAN
DECLARE		@ERR INT
SET			@ERR = 0

SET 		NOCOUNT ON

IF EXISTS (
			SELECT		* 
			FROM		information_schema.columns
			WHERE		TABLE_NAME = 'TrackCash' 
						AND COLUMN_NAME = 'Purp_ID')
BEGIN
			ALTER TABLE TrackCash DROP CONSTRAINT FK_TrackCash_Purpose
			SET @ERR = @ERR+@@ERROR
			ALTER TABLE TrackCash DROP COLUMN Purp_ID
			SET @ERR = @ERR+@@ERROR
END

IF @ERR = 0 BEGIN
	PRINT 'Ok: ' + CONVERT(VARCHAR,@@TRANCOUNT)
	COMMIT
END ELSE BEGIN
	PRINT '!!!!!!!!!!!!! Ooooooooooops: ' + CONVERT(VARCHAR,@ERR) + ' !!!!!!!!!!!!!!!!!!!'
	ROLLBACK
END
GO


----------------------------------------------------------------------------------------
PRINT 'Dobawqme kolona Broker w PubObjBrakDiscount '
GO
----------------------------------------------------------------------------------------

BEGIN TRAN
DECLARE		@ERR INT
SET			@ERR = 0

SET 		NOCOUNT ON

IF NOT EXISTS (
			SELECT		* 
			FROM		information_schema.columns
			WHERE		TABLE_NAME = 'PubObjBrakDisc' 
						AND COLUMN_NAME = 'Broker')
BEGIN
			ALTER TABLE PubObjBrakDisc ADD
				Broker decimal(9, 6) NOT NULL DEFAULT 0
END
SET	@ERR = @ERR+@@ERROR

IF @ERR = 0 BEGIN
	PRINT 'Ok: ' + CONVERT(VARCHAR,@@TRANCOUNT)
	COMMIT
END ELSE BEGIN
	PRINT '!!!!!!!!!!!!! Ooooooooooops: ' + CONVERT(VARCHAR,@ERR) + ' !!!!!!!!!!!!!!!!!!!'
	ROLLBACK
END
GO

----------------------------------------------------------------------------------------
PRINT 'Dobawqme kolona Broker w Main_Dev '
GO
----------------------------------------------------------------------------------------

BEGIN TRAN
DECLARE		@ERR INT
SET			@ERR = 0

SET 		NOCOUNT ON

IF NOT EXISTS (
			SELECT		* 
			FROM		information_schema.columns
			WHERE		TABLE_NAME = 'Main_Dev' 
						AND COLUMN_NAME = 'Broker')
BEGIN
			ALTER TABLE Main_Dev ADD
				Broker decimal(9, 6) NOT NULL DEFAULT 0
END
SET	@ERR = @ERR+@@ERROR

IF @ERR = 0 BEGIN
	PRINT 'Ok: ' + CONVERT(VARCHAR,@@TRANCOUNT)
	COMMIT
END ELSE BEGIN
	PRINT '!!!!!!!!!!!!! Ooooooooooops: ' + CONVERT(VARCHAR,@ERR) + ' !!!!!!!!!!!!!!!!!!!'
	ROLLBACK
END
GO


----------------------------------------------------------------------------------------
PRINT 'TrackCash kolona DocT oprawqme tipa ot CHAR(5) na VARCHAR(10)'
GO
----------------------------------------------------------------------------------------

BEGIN TRAN
DECLARE		@ERR INT
SET			@ERR = 0

SET 		NOCOUNT ON

ALTER TABLE TrackCash ALTER COLUMN DocN VARCHAR(10) NULL
SET @ERR = @ERR+@@ERROR

IF @ERR = 0 BEGIN
	PRINT 'Ok: ' + CONVERT(VARCHAR,@@TRANCOUNT)
	COMMIT
END ELSE BEGIN
	PRINT '!!!!!!!!!!!!! Ooooooooooops: ' + CONVERT(VARCHAR,@ERR) + ' !!!!!!!!!!!!!!!!!!!'
	ROLLBACK
END
GO


----------------------------------------------------------------------------------------
PRINT 'Dobawqme prowerka w kasa za kolona Suma da e samo do wtoriq znak'
GO
----------------------------------------------------------------------------------------

BEGIN TRAN
DECLARE		@ERR INT
SET			@ERR = 0

SET 		NOCOUNT ON

IF NOT EXISTS (
			SELECT		* 
			FROM		INFORMATION_SCHEMA.CHECK_Constraints
			WHERE		CONSTRAINT_NAME = 'CK_Cash_Suma_2digits')
BEGIN
			ALTER TABLE Cash ADD CONSTRAINT CK_Cash_Suma_2digits 
					CHECK (Suma = ROUND(Suma, 2))
END
SET @ERR = @ERR+@@ERROR

IF @ERR = 0 BEGIN
	PRINT 'Ok: ' + CONVERT(VARCHAR,@@TRANCOUNT)
	COMMIT
END ELSE BEGIN
	PRINT '!!!!!!!!!!!!! Ooooooooooops: ' + CONVERT(VARCHAR,@ERR) + ' !!!!!!!!!!!!!!!!!!!'
	ROLLBACK
END
GO

----------------------------------------------------------------------------------------
PRINT 'Dobawqme kolona Broker w Contragents'
GO
----------------------------------------------------------------------------------------

BEGIN TRAN
DECLARE		@ERR INT
SET			@ERR = 0

SET 		NOCOUNT ON

IF NOT EXISTS (
			SELECT		* 
			FROM		information_schema.columns
			WHERE		TABLE_NAME = 'Contragents' 
						AND COLUMN_NAME = 'Broker')
BEGIN
			ALTER TABLE Contragents ADD
				Broker decimal(9, 6) NOT NULL DEFAULT 0
END
SET	@ERR = @ERR+@@ERROR

IF @ERR = 0 BEGIN
	PRINT 'Ok: ' + CONVERT(VARCHAR,@@TRANCOUNT)
	COMMIT
END ELSE BEGIN
	PRINT '!!!!!!!!!!!!! Ooooooooooops: ' + CONVERT(VARCHAR,@ERR) + ' !!!!!!!!!!!!!!!!!!!'
	ROLLBACK
END
GO

----------------------------------------------------------------------------------------
PRINT 'Mahame koloni IsIntPrs i Prs_CODE ot Contragetns'
GO
----------------------------------------------------------------------------------------

BEGIN TRAN
DECLARE		@ERR INT
SET			@ERR = 0

SET 		NOCOUNT ON

IF  EXISTS (
			SELECT		* 
			FROM		information_schema.columns
			WHERE		TABLE_NAME = 'Contragents' 
						AND COLUMN_NAME = 'IsIntPrs')
BEGIN
			ALTER TABLE Contragents DROP CONSTRAINT DF_Contragents_isIntPrs
			SET @ERR = @ERR+@@ERROR
	
			ALTER TABLE Contragents DROP COLUMN IsIntPrs
			SET @ERR = @ERR+@@ERROR
END

IF  EXISTS (
			SELECT		* 
			FROM		information_schema.columns
			WHERE		TABLE_NAME = 'Contragents' 
						AND COLUMN_NAME = 'Prs_CODE')
BEGIN
			ALTER TABLE Contragents DROP CONSTRAINT FK_Contragents_Contragents
			SET @ERR = @ERR+@@ERROR
	
			ALTER TABLE Contragents DROP COLUMN Prs_CODE
			SET @ERR = @ERR+@@ERROR
END

IF @ERR = 0 BEGIN
	PRINT 'Ok: ' + CONVERT(VARCHAR,@@TRANCOUNT)
	COMMIT
END ELSE BEGIN
	PRINT '!!!!!!!!!!!!! Ooooooooooops: ' + CONVERT(VARCHAR,@ERR) + ' !!!!!!!!!!!!!!!!!!!'
	ROLLBACK
END
GO

----------------------------------------------------------------------------------------
PRINT 'Dobawqme kolona Acc_Vat_Suppl w MPSetup'
GO
----------------------------------------------------------------------------------------

BEGIN TRAN
DECLARE		@ERR INT
SET			@ERR = 0

SET 		NOCOUNT ON

IF NOT EXISTS (
			SELECT		* 
			FROM		information_schema.columns
			WHERE		TABLE_NAME = 'MpSetup' 
						AND COLUMN_NAME = 'Acc_Vat_Suppl')
BEGIN
			ALTER TABLE MpSetup ADD
				Acc_Vat_Suppl varchar(12)  NULL DEFAULT '4531'
END
SET	@ERR = @ERR+@@ERROR

IF @ERR = 0 BEGIN
	PRINT 'Ok: ' + CONVERT(VARCHAR,@@TRANCOUNT)
	COMMIT
END ELSE BEGIN
	PRINT '!!!!!!!!!!!!! Ooooooooooops: ' + CONVERT(VARCHAR,@ERR) + ' !!!!!!!!!!!!!!!!!!!'
	ROLLBACK
END
GO

----------------------------------------------------------------------------------------
PRINT 'Promeniame goleminata na kolonite TDInfo_morning i TDInfo_noon i dobawiame DT_SELL_DOCS_GRP_ID i  DT_SUPPL_DOCS_GRP_IDw MPSetup'
GO
----------------------------------------------------------------------------------------

BEGIN TRAN
DECLARE		@ERR INT
SET			@ERR = 0

SET 		NOCOUNT ON

IF NOT EXISTS (
			SELECT		* 
			FROM		information_schema.columns
			WHERE		TABLE_NAME = 'MpSetup' 
						AND COLUMN_NAME = 'DT_SELL_DOCS_GRP_ID')
BEGIN
			ALTER TABLE MpSetup ADD
				DT_SELL_DOCS_GRP_ID uniqueidentifier NULL 

			ALTER TABLE MpSetup ADD
				DT_SUPPL_DOCS_GRP_ID uniqueidentifier NULL 

			ALTER TABLE MpSetup ALTER COLUMN
				TDInfo_morning varchar(3000)

			ALTER TABLE MpSetup ALTER COLUMN
				TDInfo_noon varchar(3000)

END
SET	@ERR = @ERR+@@ERROR

IF @ERR = 0 BEGIN
	PRINT 'Ok: ' + CONVERT(VARCHAR,@@TRANCOUNT)
	COMMIT
END ELSE BEGIN
	PRINT '!!!!!!!!!!!!! Ooooooooooops: ' + CONVERT(VARCHAR,@ERR) + ' !!!!!!!!!!!!!!!!!!!'
	ROLLBACK
END
GO

----------------------------------------------------------------------------------------
PRINT 'Dobawqme kolona LastDDSUnRegistration w MPSetup'
GO
----------------------------------------------------------------------------------------

BEGIN TRAN
DECLARE		@ERR INT
SET			@ERR = 0

SET 		NOCOUNT ON

IF NOT EXISTS (
			SELECT		* 
			FROM		information_schema.columns
			WHERE		TABLE_NAME = 'MpSetup' 
						AND COLUMN_NAME = 'LastDDSUnRegistration')
BEGIN
			ALTER TABLE MpSetup ADD
				LastDDSUnRegistration datetime  NULL 
END
SET	@ERR = @ERR+@@ERROR

IF @ERR = 0 BEGIN
	PRINT 'Ok: ' + CONVERT(VARCHAR,@@TRANCOUNT)
	COMMIT
END ELSE BEGIN
	PRINT '!!!!!!!!!!!!! Ooooooooooops: ' + CONVERT(VARCHAR,@ERR) + ' !!!!!!!!!!!!!!!!!!!'
	ROLLBACK
END
GO

----------------------------------------------------------------------------------------
PRINT 'Mahame kolona ord_back ot Stand_BackM'
GO
----------------------------------------------------------------------------------------

BEGIN TRAN
DECLARE		@ERR INT
SET			@ERR = 0

SET 		NOCOUNT ON

IF EXISTS (
			SELECT		* 
			FROM		information_schema.columns
			WHERE		TABLE_NAME = 'Stand_BackM' 
						AND COLUMN_NAME = 'ord_back')
BEGIN
			ALTER TABLE Stand_BackM DROP COLUMN ord_back
			SET @ERR = @ERR+@@ERROR
END

IF @ERR = 0 BEGIN
	PRINT 'Ok: ' + CONVERT(VARCHAR,@@TRANCOUNT)
	COMMIT
END ELSE BEGIN
	PRINT '!!!!!!!!!!!!! Ooooooooooops: ' + CONVERT(VARCHAR,@ERR) + ' !!!!!!!!!!!!!!!!!!!'
	ROLLBACK
END
GO



----------------------------------------------------------------------------------------
PRINT 'Modifitsirame Pub_No ot MM/YYYY na MM.YYYY wyw Store_Saldo, Main_Dev_Pub, Stand_Back, Cash'
GO
----------------------------------------------------------------------------------------

BEGIN TRAN
DECLARE		@ERR INT
SET			@ERR = 0

SET 		NOCOUNT ON

DECLARE		@SQL		VARCHAR(8000)
SET			@SQL = ''

IF			OBJECT_ID('tempdb..#tmp') IS NOT NULL 
			DROP TABLE #tmp
SET @ERR = @ERR+@@ERROR

SELECT		*
INTO		#tmp
from		information_schema.columns
where		column_name = 'pub_no'
SET @ERR = @ERR+@@ERROR


UPDATE		#tmp
SET 		@SQL = @SQL + 'UPDATE ' + table_name + ' SET Pub_No = REPLACE(Pub_No, ''/'', ''.'') WHERE Pub_No LIKE ''%/%''' + CHAR(10) + CHAR(10)
from		#tmp
SET @ERR = @ERR+@@ERROR

EXEC		(@SQL)
SET @ERR = @ERR+@@ERROR

IF @ERR = 0 BEGIN
	PRINT 'Ok: ' + CONVERT(VARCHAR,@@TRANCOUNT)
	COMMIT
END ELSE BEGIN
	PRINT '!!!!!!!!!!!!! Ooooooooooops: ' + CONVERT(VARCHAR,@ERR) + ' !!!!!!!!!!!!!!!!!!!'
	ROLLBACK
END
GO

----------------------------------------------------------------------------------------
PRINT 'Dobawqme index po mdp_ID s Sales_rows'
GO
----------------------------------------------------------------------------------------

BEGIN TRAN
DECLARE		@ERR INT
SET			@ERR = 0

SET 		NOCOUNT ON

IF NOT EXISTS (
			SELECT		* 
			FROM		sysindexes
			WHERE		name = 'IX_sales_Rows')
BEGIN
			CREATE NONCLUSTERED INDEX IX_sales_Rows ON dbo.sales_Rows
			(
			Mdp_ID
			) ON [PRIMARY]
END
SET	@ERR = @ERR+@@ERROR

IF @ERR = 0 BEGIN
	PRINT 'Ok: ' + CONVERT(VARCHAR,@@TRANCOUNT)
	COMMIT
END ELSE BEGIN
	PRINT '!!!!!!!!!!!!! Ooooooooooops: ' + CONVERT(VARCHAR,@ERR) + ' !!!!!!!!!!!!!!!!!!!'
	ROLLBACK
END
GO

----------------------------------------------------------------------------------------
PRINT 'Modifitsirame Pub_No ot MM.YYYY na MM.YY wyw Store_Saldo, Main_Dev_Pub, Stand_Back, Cash'
GO
----------------------------------------------------------------------------------------

BEGIN TRAN
DECLARE		@ERR INT
SET			@ERR = 0

SET 		NOCOUNT ON

DECLARE		@SQL		VARCHAR(8000)
SET			@SQL = ''

IF			OBJECT_ID('tempdb..#tmp') IS NOT NULL 
			DROP TABLE #tmp
SET @ERR = @ERR+@@ERROR

SELECT		*
INTO		#tmp
from		information_schema.columns
where		column_name = 'pub_no'
SET @ERR = @ERR+@@ERROR


UPDATE		#tmp
SET 		@SQL = @SQL + 'UPDATE ' + table_name + ' SET Pub_No = REPLACE(Pub_No, ''.20'', ''.'') WHERE Pub_No LIKE ''%.20%''' + CHAR(10) + CHAR(10)
from		#tmp
SET @ERR = @ERR+@@ERROR

EXEC		(@SQL)
SET @ERR = @ERR+@@ERROR

IF @ERR = 0 BEGIN
	PRINT 'Ok: ' + CONVERT(VARCHAR,@@TRANCOUNT)
	COMMIT
END ELSE BEGIN
	PRINT '!!!!!!!!!!!!! Ooooooooooops: ' + CONVERT(VARCHAR,@ERR) + ' !!!!!!!!!!!!!!!!!!!'
	ROLLBACK
END
GO

----------------------------------------------------------------------------------------
PRINT 'Uvelichawame Contragents.Bulstat na VARCHAR(14)'
GO
----------------------------------------------------------------------------------------

BEGIN TRAN
DECLARE		@ERR INT
SET			@ERR = 0

SET 		NOCOUNT ON

ALTER TABLE Contragents ALTER COLUMN Bulstat VARCHAR(14)
SET	@ERR = @ERR+@@ERROR

IF @ERR = 0 BEGIN
	PRINT 'Ok: ' + CONVERT(VARCHAR,@@TRANCOUNT)
	COMMIT
END ELSE BEGIN
	PRINT '!!!!!!!!!!!!! Ooooooooooops: ' + CONVERT(VARCHAR,@ERR) + ' !!!!!!!!!!!!!!!!!!!'
	ROLLBACK
END
GO

----------------------------------------------------------------------------------------
PRINT 'Dobawqme extended properties MS_Description na MPSetup'
GO
----------------------------------------------------------------------------------------

BEGIN TRAN
DECLARE		@ERR INT
SET			@ERR = 0

IF NOT EXISTS (SELECT * FROM ::fn_listextendedproperty('MS_Description', 'user', 'dbo', 'table', 'MPSetup', 'column', NULL))
BEGIN
	DECLARE @v sql_variant 
	SET @v = N'   '
	EXECUTE sp_addextendedproperty N'MS_Description', @v, N'user', N'dbo', N'table', N'MPSetup', N'column', N'CG_potrebitel'
	SET	@ERR = @ERR+@@ERROR
	SET @v = N' '
	EXECUTE sp_addextendedproperty N'MS_Description', @v, N'user', N'dbo', N'table', N'MPSetup', N'column', N'Post_driver'
	SET	@ERR = @ERR+@@ERROR
	SET @v = N'  '
	EXECUTE sp_addextendedproperty N'MS_Description', @v, N'user', N'dbo', N'table', N'MPSetup', N'column', N'Default_Cash'
	SET	@ERR = @ERR+@@ERROR
	SET @v = N'    '
	EXECUTE sp_addextendedproperty N'MS_Description', @v, N'user', N'dbo', N'table', N'MPSetup', N'column', N'TDInfo_morning'
	SET	@ERR = @ERR+@@ERROR
	SET @v = N'    '
	EXECUTE sp_addextendedproperty N'MS_Description', @v, N'user', N'dbo', N'table', N'MPSetup', N'column', N'TDInfo_noon'
	SET	@ERR = @ERR+@@ERROR
	SET @v = N'", , ":        .'
	EXECUTE sp_addextendedproperty N'MS_Description', @v, N'user', N'dbo', N'table', N'MPSetup', N'column', N'Auto_Order'
	SET	@ERR = @ERR+@@ERROR
	SET @v = N'0 -   ; 1 -    ; 2 -  .  ; 3 - "1" + "2"'
	EXECUTE sp_addextendedproperty N'MS_Description', @v, N'user', N'dbo', N'table', N'MPSetup', N'column', N'SecurityLevel'
	SET	@ERR = @ERR+@@ERROR
	SET @v = N'       '
	EXECUTE sp_addextendedproperty N'MS_Description', @v, N'user', N'dbo', N'table', N'MPSetup', N'column', N'MaxLogLines'
	SET	@ERR = @ERR+@@ERROR
	SET @v = N'   '
	EXECUTE sp_addextendedproperty N'MS_Description', @v, N'user', N'dbo', N'table', N'MPSetup', N'column', N'StoreStepGener'
	SET	@ERR = @ERR+@@ERROR
	SET @v = N'   '
	EXECUTE sp_addextendedproperty N'MS_Description', @v, N'user', N'dbo', N'table', N'MPSetup', N'column', N'Store_Cosm'
	SET	@ERR = @ERR+@@ERROR
	SET @v = N'     ""  '
	EXECUTE sp_addextendedproperty N'MS_Description', @v, N'user', N'dbo', N'table', N'MPSetup', N'column', N'PreviewLines'
	SET	@ERR = @ERR+@@ERROR
	SET @v = N'     '
	EXECUTE sp_addextendedproperty N'MS_Description', @v, N'user', N'dbo', N'table', N'MPSetup', N'column', N'LockStoreDocColumns'
	SET	@ERR = @ERR+@@ERROR
	SET @v = N'       payment helper formata. '
	EXECUTE sp_addextendedproperty N'MS_Description', @v, N'user', N'dbo', N'table', N'MPSetup', N'column', N'PHalperDateFilter'
	SET	@ERR = @ERR+@@ERROR
	SET @v = N'  '
	EXECUTE sp_addextendedproperty N'MS_Description', @v, N'user', N'dbo', N'table', N'MPSetup', N'column', N'DefCurrency_ID'
	SET	@ERR = @ERR+@@ERROR
	SET @v = N'  '
	EXECUTE sp_addextendedproperty N'MS_Description', @v, N'user', N'dbo', N'table', N'MPSetup', N'column', N'DefMeasure_ID'
	SET	@ERR = @ERR+@@ERROR
	SET @v = N'  '
	EXECUTE sp_addextendedproperty N'MS_Description', @v, N'user', N'dbo', N'table', N'MPSetup', N'column', N'DefRate'
	SET	@ERR = @ERR+@@ERROR
	SET @v = N'    '
	EXECUTE sp_addextendedproperty N'MS_Description', @v, N'user', N'dbo', N'table', N'MPSetup', N'column', N'invPlace'
	SET	@ERR = @ERR+@@ERROR
	SET @v = N'  '
	EXECUTE sp_addextendedproperty N'MS_Description', @v, N'user', N'dbo', N'table', N'MPSetup', N'column', N'VAT'
	SET	@ERR = @ERR+@@ERROR
	SET @v = N'  -  '
	EXECUTE sp_addextendedproperty N'MS_Description', @v, N'user', N'dbo', N'table', N'MPSetup', N'column', N'Acc_Inv'
	SET	@ERR = @ERR+@@ERROR
	SET @v = N'   '
	EXECUTE sp_addextendedproperty N'MS_Description', @v, N'user', N'dbo', N'table', N'MPSetup', N'column', N'Acc_Vat_Sell'
	SET	@ERR = @ERR+@@ERROR
	SET @v = N'         '
	EXECUTE sp_addextendedproperty N'MS_Description', @v, N'user', N'dbo', N'table', N'MPSetup', N'column', N'Grp_Inv_Store'
	SET	@ERR = @ERR+@@ERROR
	SET @v = N'        '
	EXECUTE sp_addextendedproperty N'MS_Description', @v, N'user', N'dbo', N'table', N'MPSetup', N'column', N'AutoGenAcc'
	SET	@ERR = @ERR+@@ERROR
	SET @v = N'    '
	EXECUTE sp_addextendedproperty N'MS_Description', @v, N'user', N'dbo', N'table', N'MPSetup', N'column', N'Acc_Amort'
	SET	@ERR = @ERR+@@ERROR
	SET @v = N''
	EXECUTE sp_addextendedproperty N'MS_Description', @v, N'user', N'dbo', N'table', N'MPSetup', N'column', N'DTInvoice'
	SET	@ERR = @ERR+@@ERROR
	SET @v = N' '
	EXECUTE sp_addextendedproperty N'MS_Description', @v, N'user', N'dbo', N'table', N'MPSetup', N'column', N'DTCreditNote'
	SET	@ERR = @ERR+@@ERROR
	SET @v = N'  '
	EXECUTE sp_addextendedproperty N'MS_Description', @v, N'user', N'dbo', N'table', N'MPSetup', N'column', N'DTPKO'
	SET	@ERR = @ERR+@@ERROR
	SET @v = N'       '
	EXECUTE sp_addextendedproperty N'MS_Description', @v, N'user', N'dbo', N'table', N'MPSetup', N'column', N'DefPKOPurpose_ID'
	SET	@ERR = @ERR+@@ERROR
	SET @v = N'       ;0-;1-'
	EXECUTE sp_addextendedproperty N'MS_Description', @v, N'user', N'dbo', N'table', N'MPSetup', N'column', N'PKOGType'
	SET	@ERR = @ERR+@@ERROR
	SET @v = N'1 -       ; 0 -    '
	EXECUTE sp_addextendedproperty N'MS_Description', @v, N'user', N'dbo', N'table', N'MPSetup', N'column', N'PKOFromSaleGener'
	SET	@ERR = @ERR+@@ERROR
	SET @v = N'  '
	EXECUTE sp_addextendedproperty N'MS_Description', @v, N'user', N'dbo', N'table', N'MPSetup', N'column', N'Acc_Vat_Suppl'
	SET	@ERR = @ERR+@@ERROR
	SET @v = N'ID     '
	EXECUTE sp_addextendedproperty N'MS_Description', @v, N'user', N'dbo', N'table', N'MPSetup', N'column', N'DT_SUPPL_DOCS_GRP_ID'
	SET	@ERR = @ERR+@@ERROR
	SET @v = N'ID     '
	EXECUTE sp_addextendedproperty N'MS_Description', @v, N'user', N'dbo', N'table', N'MPSetup', N'column', N'DT_SELL_DOCS_GRP_ID'
	SET	@ERR = @ERR+@@ERROR
END

IF @ERR = 0 BEGIN
	PRINT 'Ok: ' + CONVERT(VARCHAR,@@TRANCOUNT)
	COMMIT
END ELSE BEGIN
	PRINT '!!!!!!!!!!!!! Ooooooooooops: ' + CONVERT(VARCHAR,@ERR) + ' !!!!!!!!!!!!!!!!!!!'
	ROLLBACK
END
GO


----------------------------------------------------------------------------------------
PRINT 'Dobawqne na kolona RepPeriodic wyw Contragents'
GO
----------------------------------------------------------------------------------------

BEGIN TRAN
DECLARE		@ERR INT
SET			@ERR = 0

SET 		NOCOUNT ON

IF NOT EXISTS (
			SELECT		* 
			FROM		information_schema.columns
			WHERE		TABLE_NAME = 'Contragents' 
						AND COLUMN_NAME = 'RepPeriodic')
BEGIN
			ALTER TABLE Contragents ADD
				RepPeriodic INT NULL 
END
SET	@ERR = @ERR+@@ERROR

IF @ERR = 0 BEGIN
	PRINT 'Ok: ' + CONVERT(VARCHAR,@@TRANCOUNT)
	COMMIT
END ELSE BEGIN
	PRINT '!!!!!!!!!!!!! Ooooooooooops: ' + CONVERT(VARCHAR,@ERR) + ' !!!!!!!!!!!!!!!!!!!'
	ROLLBACK
END
GO


---------------------------------------------------------------------------------------
PRINT 'trg_Contragents_Priznaci_Update replikira samo ucsCgtFirm kym schet priznatsi'
GO
----------------------------------------------------------------------------------------

BEGIN TRAN
DECLARE		@ERR INT
SET			@ERR = 0

SET 		NOCOUNT ON

EXEC (
'ALTER   TRIGGER [trg_Contragents_Priznaci_Update] ON dbo.Contragents 
FOR INSERT, UPDATE
AS
/*------------------------------------------------------------------------
    imPress Manager
    Copyright (c) 2000-2002 UniCont Soft

         (m_PR)

    Modifications: 
	  2002-03-06 Rumen - Initial implementation
	  2002-03-20 WQW - fix
	  2002-09-11 WQW - samo Type = 5 (ucsCgtFirm) se replikirat w priznatsi
	  2002-09-22 WQW - syshto i dostawchitsi (Type = 1)
*/------------------------------------------------------------------------
SET			NOCOUNT ON

-- insert actions - insert the new contragent in m_PR
INSERT INTO m_PR (ID
			, Code
			, Name
			, PrCategory_ID
			, IsSystem)
SELECT 		i.ID
			, i.CODE
			, i.Name
			, 1 -- PrCat = 1: contragent
			, 0
FROM 		inserted i
LEFT JOIN 	m_PR m 
ON 			i.ID = m.ID
WHERE		m.ID IS NULL
			AND i.Type IN (1,5) -- samo dostawchitsi i firmi

--- update modified
IF 			UPDATE(Code) 
			OR UPDATE(Type) 
			OR UPDATE([Name])
BEGIN
			UPDATE 		m_PR
			SET			[Name] = i.[Name]
						, [PrCategory_ID] = 1
						, Code = i.Code
			FROM 		inserted i
			JOIN 		m_PR m
			ON 			i.ID = m.ID
			WHERE		m.Name != i.Name
						OR m.Code != i.Code
						OR m.PrCategory_ID != 1
END')
SET @ERR = @ERR+@@ERROR

IF @ERR = 0 BEGIN
	PRINT 'Ok: ' + CONVERT(VARCHAR,@@TRANCOUNT)
	COMMIT
END ELSE BEGIN
	PRINT '!!!!!!!!!!!!! Ooooooooooops: ' + CONVERT(VARCHAR,@ERR) + ' !!!!!!!!!!!!!!!!!!!'
	ROLLBACK
END
GO


----------------------------------------------------------------------------------------
PRINT 'Syzdawame tablitsa PubGenre i dobawqme poleta na Publication'
GO
----------------------------------------------------------------------------------------

BEGIN TRAN
DECLARE		@ERR INT
SET			@ERR = 0

SET 		NOCOUNT ON

IF OBJECT_ID('PubGenre') IS NULL 
BEGIN
		EXEC ('CREATE TABLE PubGenre (
				ID UNIQUEIDENTIFIER NOT NULL CONSTRAINT DF_PubGenre_ID DEFAULT (newid()),
				Name VARCHAR(255) NULL ,
				CONSTRAINT PK_PubGenre PRIMARY KEY CLUSTERED (ID)
			)')
		SET @ERR = @ERR+@@ERROR
		
		EXEC ('INSERT PubGenre(Name) VALUES ('''')')
		SET @ERR = @ERR+@@ERROR

		EXEC ('INSERT PubGenre(Name) VALUES ('''')')
		SET @ERR = @ERR+@@ERROR

		ALTER TABLE Publication ADD DimWidth INT NULL
			, DimHeight INT NULL
			, ISSN VARCHAR(20) NULL
			, PubGenre_ID UNIQUEIDENTIFIER NULL
			, PromotionDiscount DECIMAL(9,6) NULL
			, Picture VARCHAR(256) NULL
			, IssuesCount INT NULL

END

IF @ERR = 0 BEGIN
	PRINT 'Ok: ' + CONVERT(VARCHAR,@@TRANCOUNT)
	COMMIT
END ELSE BEGIN
	PRINT '!!!!!!!!!!!!! Ooooooooooops: ' + CONVERT(VARCHAR,@ERR) + ' !!!!!!!!!!!!!!!!!!!'
	ROLLBACK
END
GO

----------------------------------------------------------------------------------------
PRINT 'Dobawqme kolona Direction w m_DocTypes'
GO
----------------------------------------------------------------------------------------

BEGIN TRAN
DECLARE		@ERR INT
SET			@ERR = 0

SET 		NOCOUNT ON

IF NOT EXISTS (
			SELECT		* 
			FROM		information_schema.columns
			WHERE		TABLE_NAME = 'm_DocTypes' 
						AND COLUMN_NAME = 'Direction')
BEGIN
			ALTER TABLE m_DocTypes ADD
				Direction varchar(1)  NOT NULL DEFAULT 'X'
END
SET	@ERR = @ERR+@@ERROR

IF @ERR = 0 BEGIN
	PRINT 'Ok: ' + CONVERT(VARCHAR,@@TRANCOUNT)
	COMMIT
END ELSE BEGIN
	PRINT '!!!!!!!!!!!!! Ooooooooooops: ' + CONVERT(VARCHAR,@ERR) + ' !!!!!!!!!!!!!!!!!!!'
	ROLLBACK
END
GO

----------------------------------------------------------------------------------------
PRINT 'Cleanup'
GO
----------------------------------------------------------------------------------------

IF			OBJECT_ID('tempdb..#Tmp') IS NOT NULL
			DROP TABLE #Tmp